Subject: Re: [Intel-wired-lan] [PATCH iwl-net] idpf: enable WB_ON_ITR

From: Michal Kubiak <[email-masked]>
Date: Fri, 15 Dec 2023 18:32:02 +0100

On Thu, Dec 14, 2023 at 01:59:57PM +0100, Paul Menzel wrote:
> Lieber Michal,
> 
> 
> Am 13.12.23 um 14:23 schrieb Michal Kubiak:
> > On Tue, Dec 12, 2023 at 05:50:55PM +0100, Paul Menzel wrote:
> 
> > > On 12/12/23 15:55, Michal Kubiak wrote:
> > > > From: Joshua Hay <[email-masked]>
> > > > 
> > > > Tell hardware to writeback completed descriptors even when interrupts
> > > 
> > > Should you resend, the verb is spelled with a space: write back.
> > 
> > Sure, I will fix it.
> 
> Thanks.

Will be fixed in v2.

> 
> > > > are disabled. Otherwise, descriptors might not be written back until
> > > > the hardware can flush a full cacheline of descriptors. This can cause
> > > > unnecessary delays when traffic is light (or even trigger Tx queue
> > > > timeout).
> > > 
> > > How can the problem be reproduced and the patch be verified?
> 
> […]
> 
> > To be honest, I have noticed the problem during the implementation of
> > AF_XDP feature for IDPF driver. In my scenario, I had 2 Tx queues:
> >   - regular LAN Tx queue
> >   - and XDP Tx queue
> > added to the same q_vector attached to the same NAPI, so those 2 Tx
> > queues were handled in the same NAPI poll loop.
> > Then, when I started a huge Tx zero-copy trafic using AF_XDP (on the XDP
> > queue), and, at the same time, tried to xmit a few packets using the second
> > (non-XDP) queue (e.g. with scapy), I was getting the Tx timeout on that regular
> > LAN Tx queue.
> > That is why I decided to upstream this fix. With disabled writebacks,
> > there is no chance to get the completion descriptor for the queue where
> > the traffic is much lighter.
> > 
> > I have never tried to reproduce the scenario described by Joshua
> > in his original patch ("unnecessary delays when traffic is light").
> 
> Understood. Maybe you could add a summary of the above to the commit message
> or just copy and paste. I guess, it’s better than nothing. And thank you for
> upstreaming this.
> 
> 
> Kind regards,
> 
> Paul

Right. I have to add some kdocs, so I will also extend that commit message in v2.

Thanks,
Michal